unit gestimpr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, RXSpin, ExtCtrls,printers,GR32,GR32_Image,GR32_Filters,
  Mask;

type
  Tgestimp = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    margehaut: TRxSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    margebas: TRxSpinEdit;
    Label4: TLabel;
    orientation: TRadioGroup;
    formatpage: TRadioGroup;
    OK: TBitBtn;
    BitBtn2: TBitBtn;
    imprimante: TComboBox;
    Label5: TLabel;
    margegauche: TRxSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    margedroite: TRxSpinEdit;
    Label8: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label10: TLabel;
    Nombrecopies: TRxSpinEdit;
    centrevert: TButton;
    CentreHrz: TButton;
    Label11: TLabel;
    nblig: TRxSpinEdit;
    Label12: TLabel;
    nbcol: TRxSpinEdit;
    Label13: TLabel;
    espaces: TRxSpinEdit;
    Label14: TLabel;
    Panel4: TPanel;
    Label15: TLabel;
    taillim: TLabel;
    verifier: TButton;
    Avertis: TPanel;
    Label16: TLabel;
    RAZ: TButton;
    Couleur: TRadioGroup;
    ImagePage: TImage32;
    procedure FormCreate(Sender: TObject);
    procedure centrevertClick(Sender: TObject);
    procedure CentreHrzClick(Sender: TObject);
    procedure orientationClick(Sender: TObject);
    procedure margeChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure formatpageClick(Sender: TObject);
    procedure verifierClick(Sender: TObject);
    procedure RAZClick(Sender: TObject);
    procedure nbligChange(Sender: TObject);
    procedure OKClick(Sender: TObject);
  private
    { Dclarations prives}
    hpage,lpage:integer;
    ajustement:boolean;
    procedure TraceCadre;

  public
    { Dclarations publiques}
    largeurpage,hauteurpage:integer;
    nbrlig,nbrcol:integer;
    Largdocmm,Hautdocmm:integer;
    Largcadremm,Hautcadremm:integer;
    Margegauchemm,Margedroitemm,Margehautmm,Margebasmm,espacemm:integer;
    CoefHautSLarg:double;
    Bitmap32:TBitmap32;
    ImprimanteOK:boolean;
    //procedure imprime(bitmap:TBitmap);
  end;

var
  gestimp: Tgestimp;

implementation
uses GestionTextes;
{$R *.DFM}

procedure Tgestimp.FormCreate(Sender: TObject);
begin
  Caption:=C_gestimp; // Choix de l'impression
  GroupBox1.Caption:=C_gestimpGroupBox1; //  Alignement 
  Label1.Caption:=C_gestimpLabel1; // marge du haut
  Label2.Caption:=C_gestimpLabel2; // mm
  Label3.Caption:=C_gestimpLabel3; // marge du bas
  Label4.Caption:=C_gestimpLabel2; // mm
  Label5.Caption:=C_gestimpLabel5; // marge gauche
  Label6.Caption:=C_gestimpLabel2; // mm
  Label7.Caption:=C_gestimpLabel7; // marge droite
  Label8.Caption:=C_gestimpLabel2; // mm
  centrevert.Caption:=C_gestimpcentrevert; // Centrer verticalement
  CentreHrz.Caption:=C_gestimpCentreHrz; // Centrer horizontalement
  RAZ.Caption:=C_gestimpRAZ; // RAZ
  orientation.Caption:=C_gestimporientation; //  orientation de la page 
  formatpage.Caption:=C_gestimpformatpage; //  Format de la page 
  imprimante.Text:=C_gestimpimprimante; // imprimante
  Label11.Caption:=C_gestimpLabel111+Chr(13)+Chr(10)+C_gestimpLabel11; // lignes
  Label12.Caption:=C_gestimpLabel111+Chr(13)+Chr(10)+C_gestimpLabel12; // colonnes
  Label13.Caption:=C_gestimpLabel13; // espaces
  Label14.Caption:=C_gestimpLabel2; // mm
  Label10.Caption:=C_gestimpLabel10; // nombre de copies
  Label15.Caption:=C_gestimpLabel15; // taille de l'image (mm) :
  verifier.Caption:=C_FormPrinccorriger1; // Vrifier
  Label16.Caption:=C_gestimpLabel161+Chr(13)+Chr(10)+C_gestimpLabel16; // Ajustez les valeurs
  Couleur.Caption:=C_gestimpCouleur; //  Couleur 
  ImprimanteOK:=True;
  try
    imprimante.Items.Clear;
    if (Printer.Printers<>nil) and (Printer.Printers.Count>0) and (Printer.PrinterIndex>-1) then
      begin
        imprimante.Items.AddStrings(Printer.Printers);
        imprimante.ItemIndex:=Printer.PrinterIndex;
      end
    else ImprimanteOK:=False;
  except
    ImprimanteOK:=False;
    Exit;
  end;
  lpage:=210;
  hpage:=297;
  nbrcol:=1;
  nbrlig:=1;
  CoefHautSLarg:=1;
  Largcadremm:=190;
  Hautcadremm:=277;
  Verifier.visible:=True;
  Largeurpage:=lpage;
  Hauteurpage:=hpage;
  Margegauchemm:=10;
  Margedroitemm:=10;
  Margehautmm:=10;
  Margebasmm:=10;
  espacemm:=5;
  ajustement:=false;
  Bitmap32:=TBitmap32.Create;
end;
{procedure Tgestimp.imprime(bitmap:Tbitmap);
var
  coeff:real;
  Rect:TRect;
  i,j,k,Dx:integer;
  hautimp,largimp,espacehimp,espacevimp,margehautimp,margegaucheimp:integer;
begin
  Printer.PrinterIndex:=gestimp.imprimante.ItemIndex;
  if orientation.ItemIndex=0 then Printer.Orientation:=poPortrait
  else Printer.Orientation:=poLandscape;
  coeff:=Printer.PageWidth/largeurpage;
  hautimp:=Round(Hautdocmm * coeff);
  largimp:=Round(Largdocmm * coeff);
  espacevimp:=Round((Espacemm + Hautdocmm)* coeff);
  espacehimp:=Round((Espacemm + Largdocmm)* coeff);
  margehautimp:=Round(Margehautmm * coeff);
  margegaucheimp:=Round(MargeGauchemm * coeff);
  Printer.Copies:=Nombrecopies.AsInteger;
  Printer.BeginDoc;
      for j:=0 to gestimp.nbrlig-1 do
        for k:=0 to gestimp.nbrcol-1 do
          begin
            Rect.top:=margehautimp+j*espacevimp;
            Rect.left:=margegaucheimp+k*espacehimp;
            Rect.Bottom:=Rect.top+hautimp;
            Rect.right:=Rect.Left+largimp;
            Printer.Canvas.StretchDraw(Rect,Bitmap);
          end;
  Printer.EndDoc;
  Printer.Copies:=1;
end;}
procedure Tgestimp.centrevertClick(Sender: TObject);
Var
  moyenne:integer;
begin
  moyenne:=(margehaut.AsInteger+margebas.AsInteger) div 2;
  Margehaut.Value:=moyenne;
  Margebas.Value:=moyenne;
  Margehautmm:=moyenne;
  margebasmm:=moyenne;
end;

procedure Tgestimp.CentreHrzClick(Sender: TObject);
Var
  moyenne:integer;
begin
  moyenne:=(Margegauche.AsInteger+Margedroite.AsInteger) div 2;
  Margegauche.Value:=moyenne;
  Margedroite.Value:=moyenne;
  Margegauchemm:=moyenne;
  margedroitemm:=moyenne;
end;

procedure Tgestimp.orientationClick(Sender: TObject);
begin
  if orientation.ItemIndex=0 then
    begin
      //Printer.Orientation:=poPortrait
      largeurpage:=lpage;
      hauteurpage:=hpage;
      ImagePage.Width:=130;
      ImagePage.Height:=183;
      ImagePage.Top:=16;
      ImagePage.Left:=392;
    end
  else
    begin
      //Printer.Orientation:=poLandscape;
      ImagePage.Width:=183;
      ImagePage.Height:=130;
      ImagePage.Top:=40;
      ImagePage.Left:=368;  
      largeurpage:=hpage;
      hauteurpage:=lpage;
    end;
  verifier.Visible:=True;
  RAZClick(Sender);
end;

procedure Tgestimp.margeChange(Sender: TObject);
begin
  if ajustement then exit;
  try
    Margegauchemm:=Margegauche.AsInteger;
    Margedroitemm:=Margedroite.AsInteger;
    Margehautmm:=Margehaut.AsInteger;
    Margebasmm:=Margebas.AsInteger;
    espacemm:=Espaces.AsInteger;
  except
  end;
  verifier.Visible:=True;
end;
procedure Tgestimp.tracecadre;
var
  valeur,dif:integer;
  i,j:integer;
  x0,Y0,ht,lg,dx,dy:integer;
  ecxy:real;
begin
  ajustement:=True;
  Valeur:=(largeurpage-margegauchemm-margedroitemm-(nbrcol-1)*espacemm)div nbrcol;
  if (Valeur>5) and (Round(Valeur * CoefHautSLarg)>5) then
    begin
      Largdocmm:=Valeur;
      Avertis.Visible:=False;
    end
  else
    begin
      Avertis.Visible:=True;
      ajustement:=false;
      Exit;
    end;
  Valeur:=(hauteurpage-margehautmm-margebasmm-(nbrlig-1)*espacemm)div nbrlig;
  if (Round(Largdocmm * CoefHautSLarg)>Valeur) then
    begin
      Hautdocmm:=Valeur;
      Largdocmm:=Round(Hautdocmm/CoefHautSLarg);
      dif:=largeurpage-margegauchemm-margedroitemm-LargDocmm*nbrcol-(nbrcol-1)*espacemm;
      if dif>1 then
        begin
          margegauchemm:=margegauchemm+(dif div 2);
          margedroitemm:=margedroitemm+(dif div 2);
          margegauche.Value:=margegauchemm;
          margedroite.Value:=margedroitemm;
        end;
    end
  else
    begin
      Hautdocmm:=Round(Largdocmm * CoefHautSLarg);
      dif:=hauteurpage-margehautmm-margebasmm-HautDocmm*nbrlig-(nbrlig-1)*espacemm;
      if dif>1 then
        begin
          margehautmm:=margehautmm+(dif div 2);
          margebasmm:=margebasmm+(dif div 2);
          margehaut.Value:=margehautmm;
          margebas.Value:=margebasmm;
        end;
    end;
  if Hautdocmm<5 then
    begin
      Avertis.Visible:=True;
      ajustement:=false;
      Exit;
    end;
  ajustement:=false;
  Largcadremm:=largeurpage-margedroitemm-margegauchemm;
  Hautcadremm:=hauteurpage-margebasmm-margehautmm;
  taillim.Caption:=IntToStr(Largdocmm)+' x '+IntToStr(Hautdocmm);
  ImagePage.Bitmap.Width:=ImagePage.Width;
  ImagePage.Bitmap.Height:=ImagePage.Height;
  ImagePage.Bitmap.Clear(clWhite32);
  ecxy:=183/297;
  X0:=Round(margegauchemm*ecxy);
  Y0:=Round(margehautmm*ecxy);
  ht:=Round(Hautdocmm*ecxy);
  lg:=Round(Largdocmm*ecxy);
  dX:=Round((Largdocmm+espacemm)*ecxy);
  dY:=Round((Hautdocmm+espacemm)*ecxy);
  For i:=0 to nbrlig-1 do
    For j:=0 to nbrcol-1 do
      begin
        ImagePage.Bitmap.FillRectS(X0+j*dX,Y0+i*dY,X0+j*dX+lg,Y0+i*dY+ht,clLightGray32);
      end;
  Avertis.Visible:=False;
  Verifier.Visible:=False;
end;
procedure Tgestimp.FormActivate(Sender: TObject);
begin
  Verifier.Visible:=True;
  If (Bitmap32.Width<5)or(Bitmap32.Height<5) then
    begin
//      Messagedlg('Le document est trop petit',mtWarning,[mbOK],0);
      Messagedlg(M_Ledocumentesttropp,mtWarning,[mbOK],0);
      ModalResult:=mrCancel;
      Close;
    end;
  CoefHautSLarg:=Bitmap32.Height/Bitmap32.Width;
  Tracecadre;
end;

procedure Tgestimp.formatpageClick(Sender: TObject);
begin
  if formatpage.ItemIndex=0 then
    begin
      lpage:=210;
      hpage:=297;
    end
  else
    begin
      lpage:=297;
      hpage:=420;
    end;
  if orientation.ItemIndex=0 then
    begin
      largeurpage:=lpage;
      hauteurpage:=hpage;
    end
  else
    begin
      largeurpage:=hpage;
      hauteurpage:=lpage;
    end;
  Tracecadre;
  Verifier.Visible:=True;
end;

procedure Tgestimp.verifierClick(Sender: TObject);
begin
  tracecadre;
end;

procedure Tgestimp.RAZClick(Sender: TObject);
begin
  Ajustement:=true;
  Margehautmm:=10;
  Margebasmm:=10;
  Margegauchemm:=10;
  Margedroitemm:=10;
  Margehaut.Value:=10;
  Margebas.Value:=10;
  Margegauche.Value:=10;
  Margedroite.Value:=10;
  Ajustement:=false;
  tracecadre;
end;

procedure Tgestimp.nbligChange(Sender: TObject);
begin
  try
    nbrlig:=nblig.AsInteger;
    nbrcol:=nbcol.AsInteger;
    Verifier.Visible:=True;
    RAZClick(Sender);
  except
  end;
end;

procedure Tgestimp.OKClick(Sender: TObject);
Var
  coeff:real;
  Rect:TRect;
  i,j,k,ncop:integer;   //,Dx
  hautimp,largimp,espacehimp,espacevimp,margehautimp,margegaucheimp:integer;
  BitmapTp:TBitmap;
begin
  if couleur.ItemIndex>0 then
    ColorToGrayscale(Bitmap32,Bitmap32);
    BitmapTp:=TBitmap.create;
    try
      Bitmaptp.assign(Bitmap32);
      Printer.PrinterIndex:=imprimante.ItemIndex;
      if orientation.ItemIndex=0 then Printer.Orientation:=poPortrait
      else Printer.Orientation:=poLandscape;
      coeff:=Printer.PageWidth/gestimp.largeurpage;
      hautimp:=Round(Hautdocmm * coeff);
      largimp:=Round(Largdocmm * coeff);
      espacevimp:=Round((Espacemm + Hautdocmm)* coeff);
      espacehimp:=Round((Espacemm + Largdocmm)* coeff);
      margehautimp:=Round(Margehautmm * coeff);
      margegaucheimp:=Round(MargeGauchemm * coeff);
      ncop:=Nombrecopies.AsInteger;
      Printer.BeginDoc;
      for i:=1 to ncop do
        begin
          for j:=0 to nbrlig-1 do
            for k:=0 to nbrcol-1 do
              begin
                Rect.top:=margehautimp+j*espacevimp;
                Rect.left:=margegaucheimp+k*espacehimp;
                Rect.Bottom:=Rect.top+hautimp;
                Rect.right:=Rect.Left+largimp;
                Printer.Canvas.StretchDraw(Rect,Bitmaptp);
              end;
          if i<ncop then Printer.NewPage;
        end;
      Printer.EndDoc;
      Printer.Copies:=1;
    finally
      Bitmaptp.free;
    end;
end;

end.
