unit PhylTrier;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CustomGraph2, GraphTri, StdCtrls, Grids, MyNewgrid,listarray2,group2,
  ExtCtrls,StructureDonnees,Donnees, CustomGraph, GraphControlTreeCL, Buttons;// ,TreeCLGR

type
  TFormTri = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    GraphTri1: TGraphTri;
    Splitter2: TSplitter;
    PanelArbre: TPanel;
    GCT1: TGraphControlTreeCL;
    TabGrid2: TTabGrid;
    PanelGrille: TPanel;
    TabGrid1: TTabGrid;
    PanelLeg: TPanel;
    ModeCol: TRadioGroup;
    PanelBoutons: TPanel;
    BRaz: TSpeedButton;
    Panel5: TPanel;
    Bdepla: TSpeedButton;
    Bgroupes: TSpeedButton;
    PanelLegCoul: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    procedure TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
//    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GraphTri1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ModeColClick(Sender: TObject);
    procedure BdeplaClick(Sender: TObject);
    procedure BgroupesClick(Sender: TObject);
    procedure BRazClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Dclarations prives}
    procedure ChargeLangue;

  public
    { Dclarations publiques}
    ModeConstruction:boolean;
    procedure afficheArbre; // affichage de l'arbre ajout JFM 12/04/08
    function rechercherEtatDerive( caractere :String): string;
    procedure InitialiseMatrice;
    procedure ColoreMatrice;
    procedure ChargeTabGrid(retourMode:Boolean);
    procedure ReclasserTableau(TableauRef:TStrListArray);
  end;

var
  FormTri: TFormTri;

implementation

uses PhylChoi, PhylMain,math,GestionTextes;

{$R *.DFM}

function TFormTri.rechercherEtatDerive( caractere :String): string;
var
  numCar:integer;
  LeCaractereD:TCaractD;
begin
  Result:='';
  NumCar:=LaSousCollection.Caracteres.GetNumCarD(caractere);
  if (NumCar>-1) then
    begin
      LeCaractereD:=LaSousCollection.Caracteres.CarDs.Items[NumCar];
//      if LeCaractereD.TypeCarD>0 then //si ordonn mais pb avec les .cod par dfaut
//        begin
          Result:=LeCaractereD.ListeEtats[1];   //Renvoie  l'tat driv de rang 1
//        end
    end;
end;
procedure TFormTri.InitialiseMatrice;
begin
  ColoreMatrice;
  PanelGrille.Height:=Min(FormTri.Height div 2,TabGrid1.RowCount*(TabGrid1.DefaultRowHeight+1)+4);
end;
procedure TFormTri.ColoreMatrice;
Var
  i,j:integer;
  AfficheDerive:TAffichCell;
  AffichePrimitif:TAffichCell;
  UnAffichage:TAffichCell;
  carac:string;
  NumCar:integer;
  UnCarD:TCaractD;
begin
  if ColorerDerive then  // Pour colorer le fond du texte correspondant  une cellule dont l'tat est volu
    begin
      AfficheDerive.Active:=True;
      AfficheDerive.CouleurFond:=clYellow;
      AfficheDerive.CouleurTexte:=clBlack;
      AfficheDerive.styleFond:=bsSolid;
      AfficheDerive.CouleurContour:=ClBlack;
      AffichePrimitif:=AfficheDerive;
      AffichePrimitif.CouleurFond:=clWhite;
      AffichePrimitif.Active:=False;
      //AffichePrimitif.CouleurFond:=ClRed;
      //AffichePrimitif.CouleurTexte:=clBlue;
      //AffichePrimitif.styleFond:=bsDiagCross;
      UnAffichage:=AfficheDerive;
      For i:=1 to TabGrid1.ColCount-1 do
        begin
          carac:=TabGrid1.Cells[i,0];
          UnCarD:=LaSousCollection.LeCarD(carac);
          if UnCarD<>Nil then
            begin
              For j:=1 to TabGrid1.RowCount-1 do
                begin
                  if (TabGrid1.Cells[i,j]<>'?') and (UnCarD.ListeEtats.IndexOf(TabGrid1.Cells[i,j])>0) then
                  //TabGrid1.Cells[i,j]=rechercherEtatDerive(carac) then
                    begin
                      TabGrid1.AffichCell[i,j]:=UnAffichage;
                    end
                  else TabGrid1.AffichCell[i,j]:=AffichePrimitif;
                  {else if TabGrid1.Cells[i,j]=rechercherEtatPrimitif(carac) then
                     TabGrid1.AffichCell[i,j]:=AffichePrimitif;}
                end;
            end;
        end;
    end;
end;

procedure TFormTri.afficheArbre; // affichage de l'arbre ajout JFM 12/04/08
Var
  ListArray:TStrListArray;
  TreeGroup:TTreeGroup;

begin
  ListArray:=TStrListArray.createlistArray;
  FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray);
  TabGrid2.RowCount:=FormTri.TabGrid1.RowCount;
  TabGrid2.ColCount:=FormTri.TabGrid1.ColCount;
  TabGrid2.copyFromAlistArray(0,0,ListArray);
  TabGrid2.SelectAllRow(true);
  FormTri.TabGrid1.CopyListSelectCol(TabGrid2.ListSelectCol);
  //TabGrid2.Invalidate;
  TreeGroup:=TTreeGroup(GraphTri1.Model);  // jfr modifie le 19/12/05 pour le nouveau tri par boite
  if LaSousCollection.Caracteres.CodesEtats=nil then
    begin
      LaSousCollection.Caracteres.CreeCodeSEtats;
    end;

  TabGrid2.FTabCod:=LaSousCollection.Caracteres.CodesEtats;
  GCT1.InitTreeGroup(TabGrid2,TreeGroup,LaSousCollection.Caracteres.CodesEtats); //
  ListArray.Free;
end;

procedure TFormTri.TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  col,row:integer;
  AName:string;
begin
  if Not ModeConstruction then exit;
  TabGrid1.MouseToCell(X,Y,col,row);
  if (row=0) and (col<>0) and (button=mbleft) then   // (button=mbleft) rajout le 12/01
    begin
      if TabGrid1.SelectCol[col]=false then    // La fonction selfMouseDown met  false une cellule
        begin                                   // sur laquelle on a cliqu : c'est parce que pour les
          AName:=TabGrid1.Cells[col,row];         // arbres les cellules sont slectionnes d'emble
          TTreeGroup(GraphTri1.Model).Addsort(Aname);
          GraphTri1.ChangeGraphObjects;
          GraphTri1.invalidate;
          TabGrid1.SelectCol[col]:=true;  // jfr modifie le 06/09/00
          TabGrid1.invalidate;            // jfr modifie le 06/09/00
          if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
        end
      else
        begin
          AName:=TabGrid1.Cells[col,row];
          TTreeGroup(GraphTri1.Model).DeleteSort(AName);
          GraphTri1.ChangeGraphObjects;
          GraphTri1.invalidate;
          TabGrid1.SelectCol[col]:=false;  // jfr modifie le 06/09/00
          TabGrid1.invalidate;             // jfr modifie le 06/09/00
          if panelArbre.Visible then afficheArbre;  // affichage de l'arbre ajout JFM 12/04/08
        end;
    end;
  if (row=0) and (col<>0) and (button=mbright) then   // (button=mbright) rajout le 10/09/00
    begin
      if TabGrid1.SelectCol[col]=false then TabGrid1.SelectCol[col]:=true
      else TabGrid1.SelectCol[col]:=false;
    end;
end;

procedure TFormTri.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // FormPrinc.ATri:=nil;
  // GraphTri1.ChangeGraphObjects;
  // TabGrid1.SelectAllCol(false);
end;
procedure TFormTri.ReclasserTableau(TableauRef:TStrListArray);
Var
  i,j,n:integer;
  ListeSelection: TStringList;
begin
  ListeSelection:=TStringList.Create;
  For i:=1 to TabGrid1.ColCount-1 do
    if TabGrid1.SelectCol[i] then ListeSelection.Add(TabGrid1.Cells[i,0]);
  TabGrid1.SelectAllCol(False);
  TabGrid1.RowCount:=TableauRef.RowCount;
  TabGrid1.ColCount:=TableauRef.GetMaxColCount;
  TabGrid1.copyFromAlistArray(0,0,TableauRef);
  TabGrid1.AdjustColWidths;

  For i:=0 to ListeSelection.Count-1 do
    begin
      n:=TabGrid1.Rows[0].IndexOf(ListeSelection[i]);
      if n>1 then TabGrid1.SetSelectCol(n,True);
    end;
  ListeSelection.Free;
  ColoreMatrice;
end;

procedure TFormTri.ChargeTabGrid(RetourMode:boolean);
var
  ListArray: TStrListArray;
begin
  FormPrinc.ATri:=nil;
  GraphTri1.ChangeGraphObjects;
  TabGrid1.SelectAllCol(false);
  if FormPrinc.AData=Nil then FormPrinc.AData:=TStrListArray.createlistArray;
  ListArray:=FormPrinc.AData;
  if (ListArray.RowCount<2) or (ListArray.GetMaxColCount<2)  then
    begin
      if TableauCorrect then
        FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray)
      else ListArray.Assign(LaSousCollection.TabRef);
    end;
  TabGrid1.RowCount:=ListArray.RowCount;
  TabGrid1.ColCount:=ListArray.GetMaxColCount;
  TabGrid1.copyFromAlistArray(0,0,ListArray);
  TabGrid1.SelectAllRow(false);
  TabGrid1.AdjustColWidths;
  FormPrinc.Atri:=TTreeGroup.CreateTreeGroup(ListArray);
  GraphTri1.Model:=FormPrinc.Atri;
  InitialiseMatrice;
  if RetourMode then
    begin
      Bdepla.Down:=True;
      ModeConstruction:=False;
      TabGrid1.Options:=TabGrid1.Options+[goColMoving];
    end;
end;

procedure TFormTri.FormCreate(Sender: TObject);
begin
  ChargeLangue;
  FormPrinc.Fille(Self);
  GCT1.EstModifiable:=False;
  ModeConstruction:=False;
end;

 // jfr modifie le 07/03/02    fonction rajoute
procedure TFormTri.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//   if button=mbright then application.messagebox('Activer la fonction Arbre' , 'Option',mb_ok);
   if button=mbright then
     MessageDlg(M_ActiverlafonctionA,mtConfirmation,[mbOK],0);
end;

// jfr modifie le 07/03/02    fonction rajoute    Attention  modifier le fichier dfm en appellant cette fonction  travers l'inspecteur d'objet et la proprit on
// onMouseUp de graphtri
procedure TFormTri.GraphTri1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (button=mbright) and PeutAfficherArbre then // Modif JFM 10/04/08
  begin
//  if application.messagebox('Utiliser le groupement pour construire l''arbre ?' , 'Option',mb_okcancel)=IDOK  then
  if MessageDlg(M_Utiliserlegroupeme,mtConfirmation,[mbOK,mbCancel],0)=mrOK  then
    begin
      FormPrinc.Arbre.Enabled:=true;
      ArbreDApresBoites:=false;
      ArbreDApresTri:=True;
      FormPrinc.Arbre1Click(Nil);
    end;
  end;
end;

procedure TFormTri.ModeColClick(Sender: TObject);
begin
  If ModeCol.ItemIndex=0 then
    begin
      ModeConstruction:=True;
      TabGrid1.Options:=TabGrid1.Options-[goColMoving];
    end
  else
    begin
      ModeConstruction:=False;
      TabGrid1.Options:=TabGrid1.Options+[goColMoving];
    end;
end;

procedure TFormTri.BdeplaClick(Sender: TObject);
begin
  ModeConstruction:=False;
  TabGrid1.Options:=TabGrid1.Options+[goColMoving];
end;

procedure TFormTri.BgroupesClick(Sender: TObject);
begin
  ModeConstruction:=True;
  TabGrid1.Options:=TabGrid1.Options-[goColMoving];
end;

procedure TFormTri.BRazClick(Sender: TObject);
begin
  FormPrinc.ATri:=nil;
  GraphTri1.ChangeGraphObjects;
  TabGrid1.SelectAllCol(false);
  Tabgrid1.CopyToAListArray(0,0,FormPrinc.Adata);
  FormPrinc.Atri:=TTreeGroup.CreateTreeGroup(FormPrinc.Adata);
  GraphTri1.Model:=FormPrinc.Atri;
  Tabgrid1.Invalidate;
end;

procedure TFormTri.FormHide(Sender: TObject);
begin
  Tabgrid1.CopyToAListArray(0,0,FormPrinc.Adata);
end;
procedure TFormTri.ChargeLangue;
begin
  Caption:=C_FormTri; // Tri (Grouper)
  ModeCol.Caption:=C_FormTriModeCol; // Colonnes
  BRaz.Hint:=C_FormMolButton1; // Tout dslectionner
  Bdepla.Hint:=H_FormParenteBdepla; // Dplacer lignes et colonnes
  Bgroupes.Hint:=H_FormTriBgroupes; // Regrouper suivant les caractres
  Label1.Caption:=L_CaracPresent+Chr(13)+Chr(10)+L_ChezTaxon; // chez le taxon
end;

end.
